<?php

namespace FiloBlu\Newsletter\Block\LandingPage;

class LandingPage extends \Magento\Framework\View\Element\Template {

    public $_helper;
    protected $request;

    /**
     * Store manager
     *
     * @var \Magento\Store\Model\StoreManagerInterface
     */
    protected $_storeManager;
    protected $_coreRegistry;

    public function __construct(\Magento\Framework\View\Element\Template\Context $context, array $data = [], \FiloBlu\Newsletter\Helper\Data $helper, \Magento\Framework\App\Request\Http $request, \Magento\Framework\Registry $registry
    ) {
        $this->_helper = $helper;
        $this->request = $request;
        $this->_storeManager = $context->getStoreManager();
        $this->_coreRegistry = $registry;

        parent::__construct($context, $data);
    }

    public function getLandingPage() {

        if (!$this->getLandingPageEntity()) {
            $this->setLandingPageEntity($this->_coreRegistry->registry('newsletter_landingpage_entity'));
        }

        return $this->getLandingPageEntity()->getData();
    }

    public function getImageUrl($image) {
        return $this->_storeManager->getStore()->getBaseUrl(\Magento\Framework\UrlInterface::URL_TYPE_MEDIA) . "filoblu/newsletter/landingpage/image" . $image;
    }

    protected function _toHtml() {

        if (!$this->_helper->getConfig("general/enabled")) {
            return "";
        } else {
            $landing = $this->getLandingPage();
            
            $this->setTemplate('FiloBlu_Newsletter::landingpage/landing_page_' . $landing["code"] . '.phtml');

            if (!$this->getTemplateFile()) {

                $this->setTemplate('FiloBlu_Newsletter::landingpage/landing_page.phtml');
            }

            return parent::_toHtml();
        }
    }

}
